## ros-rolling-ublox-gps 2.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(ublox_gps)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

find_package(ament_cmake_ros REQUIRED)
find_package(asio REQUIRED)
find_package(diagnostic_msgs REQUIRED)
find_package(diagnostic_updater REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(rcl_interfaces REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(sensor_msgs REQUIRED)
find_package(std_msgs REQUIRED)
find_package(tf2 REQUIRED)
find_package(ublox_msgs REQUIRED)
find_package(ublox_serialization REQUIRED)

include_directories(include)

# build node
add_library(ublox_gps
  src/adr_udr_product.cpp
  src/gnss.cpp
  src/gps.cpp
  src/hp_pos_rec_product.cpp
  src/hpg_ref_product.cpp
  src/hpg_rov_product.cpp
  src/mkgmtime.c
  src/node.cpp
  src/raw_data_pa.cpp
  src/raw_data_product.cpp
  src/tim_product.cpp
  src/ublox_firmware.cpp
  src/ublox_firmware6.cpp
  src/ublox_firmware7.cpp
  src/ublox_firmware8.cpp
  src/ublox_firmware9.cpp)
ament_target_dependencies(ublox_gps
  "asio"
  "diagnostic_msgs"
  "diagnostic_updater"
  "geometry_msgs"
  "rcl_interfaces"
  "rclcpp"
  "rclcpp_components"
  "sensor_msgs"
  "std_msgs"
  "tf2"
  "ublox_msgs"
  "ublox_serialization"
)

install(TARGETS ublox_gps
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

add_executable(ublox_gps_node src/node_main.cpp)
ament_target_dependencies(ublox_gps_node
  "rclcpp"
)
target_link_libraries(ublox_gps_node ublox_gps)

# build logger node
add_executable(ublox_logger_node src/logger_node_pa.cpp src/raw_data_pa.cpp)
set_target_properties(ublox_logger_node PROPERTIES OUTPUT_NAME ublox_logger)
ament_target_dependencies(ublox_logger_node
  "rclcpp"
  "std_msgs"
)

install(TARGETS
  ublox_gps_node ublox_logger_node
  DESTINATION lib/${PROJECT_NAME}
)

rclcpp_components_register_nodes(ublox_gps
  "ublox_node::UbloxNode")

install(DIRECTORY include/
  DESTINATION include
)

ament_package()

=== debian/changelog ===
ros-rolling-ublox-gps (2.0.0-2focal) focal; urgency=high

  * Initial ROS 2 port to Dashing
  * Create publishers based on ROS parameters (#1 <https://github.com/KumarRobotics/ublox/issues/1>)
  * Make sure to reset for survey-in mode.
  * Make sure to depend on tf2 properly.
  * Make sure to have package.xml depend on ament_cmake_ros
  * Fix getting RTCM ids and rates.
  * Increase the timeout for NavPVT messages during Survey-In config.
  * Configure the base more accurately.
  * Update rover configuration.
  * Create ROS 2 launch files.
  * Finish porting configs to ROS 2.
  * Fix heading output to comply with REP-103
  * Make ublox_gps composable.
  * Fixes pointed out by clang-tidy.
  * Rename rawDataStreamPa member variable to raw_data_stream_pa
  * Fix a bug for reads of zero size.
  * Re-enable logging in the AsyncWorker.
  * Switch a couple more catch blocks to const.
  * Remove -ggdb3 flag from CMakeLists.txt.
  * Fix a few bugs pointed out by valgrind.
  * Pass the logger down to the Gps level.
  * Minor cleanup in the gps code.
  * More fixes for declaring parameters.
  * Declare more parameters.
  * Declare more parameters correctly.
  * More fixes so that we get the correct rates.
  * More fixes around the codebase.
  * Mark constants as such.
  * Remove declareRosBoolean.
  * Update configuration files for ROS 2.
  * Port ublox_gps to ROS 2.
  * Start ROS 2 port by COLCON_IGNORE everything.
  * Split the main out into its own file.
  * Move spinning out of the constructor.
  * Cleanup includes in node.{hpp,cpp}.
  * Move HpPosRecProduct class to its own files.
  * Move HpgRefProduct class to its own files.
  * Move UbloxFirmware9 class to its own files.
  * Move UbloxFirmware8 class to its own files.
  * Move UbloxFirmware7 to its own files.
  * Move UbloxFirmware7Plus class to its own header file.
  * Move UbloxFirmware6 class to its own files.
  * Move UbloxFirmware class to its own files.
  * Move RawDataProduct class into its own files.
  * Move HpgRovProduct class to its own files.
  * Move AdrUdrProduct class into its own files.
  * Move TimProduct class into its own file.
  * Make the node handle a member variable of UbloxNode.
  * Remove the last uses of the global variable.
  * Pass the nodehandle into more methods.
  * Start passing the node into functions.
  * Declare a few more booleans.
  * Declare a lot more parameters.
  * Finish removing the "enable" map.
  * Move some more boolean parameters to declarations.
  * Declare more parameters.
  * Convert a few more parameters over to being declared.
  * Declare the config_on_startup flag.
  * Make dat/set a declared parameter.
  * Make sure to declare the sbas parameter.
  * Add in ROS2-like declare and get parameters.
  * Replace templated publish call with lambdas.
  * Make fix_status_service a member variable of UbloxFirmware.
  * Move fixFromString and modelFromString into node.cpp
  * Make gps a member variable of UbloxNode.
  * Add namespaces to component_interface and fts_product.hpp
  * Minor code improvements.
  * Move FixDiagnostic class to its own file.
  * Move UbloxTopicDiagnostic to its own file.
  * Make gnss a member variable of UbloxNode.
  * Move kNavSvInfoSubscribeRate into the base class that uses it.
  * Remove kSubscribeRate.
  * Move the kDefaultMeasRate to the class that needs it.
  * Remove kROSQueueSize constant.
  * Make rtcms a member variable of UbloxNode.
  * Switch to a structure for RTCMs.
  * Make freq_diag a member variable of UbloxNode.
  * Make updater a member variable of UbloxNode.
  * Make frame_id a member variable.
  * Make config_on_startup_flag a member variable.
  * Make meas_rate a member variable.
  * Make nav_rate a class variable.
  * Lots of small code updates throughout the GPS module.
  * Get rid of global 'debug' variable.
  * Move serialization into the ublox_serialization module.
  * More rearrangement of header files to make a more sane structure.
  * Move FTSProduct class into its own file.
  * UbloxNode is not a component.
  * Move ComponentInterface to its own file.
  * Remove the one static ros::Subscriber.
  * Remove last static advertiser.
  * Switch to const references for std::string where possible.
  * Switch to more idiomatic publisher initialization.
  * Switch the one use of tf to tf2.
  * Remove 'using namespace' uses.
  * Switch to non-boost asio.
  * Remove uses of 'new' throughout the codebase.
  * Remove the last of boost from node.cpp
  * Remove most of boost from node.cpp/.hpp.
  * Remove a bunch of boost from node.cpp
  * Remove more boost.
  * Remove boost from worker.hpp
  * Remove some uses of boost from async_worker.hpp
  * Fully de-boostify callback.hpp
  * Rearrange messages.
  * Switch out boost time and mutex for std
  * Remove trailing whitespace in all files.
  * Rename header files to have .hpp extension.
  * Contributors: Chao Qu, Chris Lalancette, Mabel Zhang

 -- Gareth Cross <gcross.code@icloud.com>  Tue, 13 Oct 2020 00:00:00 -0000

ros-rolling-ublox-gps (1.2.0-2focal) focal; urgency=high

  * Add support for ZED-F9P new RELPOSNED message and provide heading output
    Fix whitespacing...
    Add RELPOSNED9 message to compile
  * Fix for corrupted diagnostics messages
    Before the diagnostic structs were copied, but the pointers in FrequencyStatusParams still pointed to the old/freed objects.
  * Show TMODE3 diagnostics OK if disabled
    Since there is no default for TMODE3 this is a deliberate choice
  * added simple (remote) logger node for raw data stream logging
  * updated raw data stream logging
    + moved all global/node functions to new class RawDataStreamPa
    (raw_data_pa .h/.c)
    + changed messagetype to uint8-multiarray
    (string can not handle non-characters)
  * fix #52 <https://github.com/KumarRobotics/ublox/issues/52>
  * FIX: overflow bug when the nano field of the NavPVT message (which is signed and can be negative) is assigned to the nsec value of a ros time stamp (which is unsigned)


=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-ublox-gps//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-ublox-gps 2.3.0

=== debian/changelog ===
ros-rolling-ublox-gps (2.3.0-2jammy) jammy; urgency=high

  * Revamp the building of the driver for modern ROS 2 practices.
  * Fix parameter declaration types. (#146 <https://github.com/KumarRobotics/ublox/issues/146>)
  * Add the types to declared parameters. (#141 <https://github.com/KumarRobotics/ublox/issues/141>)
  * Add UDP support (#140 <https://github.com/KumarRobotics/ublox/issues/140>)
  * add Ublox ZED_F9P config (#131 <https://github.com/KumarRobotics/ublox/issues/131>)
  * Fix warnings in launch.
  * [FEAT]: add launch and config directories to 'intall' package to avoid wrong launch location (#125 <https://github.com/KumarRobotics/ublox/issues/125>)
  * Fix wrong variable name in launch (#120 <https://github.com/KumarRobotics/ublox/issues/120>)
  * Contributors: CHAIWIT PHONKHEN, Chao Qu, Chris Lalancette, Daisuke Nishimatsu, Davidson Daniel Rojas Cediel, Kevin Hallenbeck

 -- Gareth Cross <gcross.code@icloud.com>  Wed, 13 Apr 2022 07:00:00 -0000

ros-rolling-ublox-gps (2.0.0-2jammy) jammy; urgency=high

  * Initial ROS 2 port to Dashing
  * Create publishers based on ROS parameters (#1 <https://github.com/KumarRobotics/ublox/issues/1>)
  * Make sure to reset for survey-in mode.
  * Make sure to depend on tf2 properly.
  * Make sure to have package.xml depend on ament_cmake_ros
  * Fix getting RTCM ids and rates.
  * Increase the timeout for NavPVT messages during Survey-In config.
  * Configure the base more accurately.
  * Update rover configuration.
  * Create ROS 2 launch files.
  * Finish porting configs to ROS 2.
  * Fix heading output to comply with REP-103
  * Make ublox_gps composable.
  * Fixes pointed out by clang-tidy.
  * Rename rawDataStreamPa member variable to raw_data_stream_pa
  * Fix a bug for reads of zero size.
  * Re-enable logging in the AsyncWorker.
  * Switch a couple more catch blocks to const.
  * Remove -ggdb3 flag from CMakeLists.txt.
  * Fix a few bugs pointed out by valgrind.
  * Pass the logger down to the Gps level.
  * Minor cleanup in the gps code.
  * More fixes for declaring parameters.
  * Declare more parameters.
  * Declare more parameters correctly.
  * More fixes so that we get the correct rates.
  * More fixes around the codebase.
  * Mark constants as such.
  * Remove declareRosBoolean.
  * Update configuration files for ROS 2.
  * Port ublox_gps to ROS 2.
  * Start ROS 2 port by COLCON_IGNORE everything.
  * Split the main out into its own file.
  * Move spinning out of the constructor.
  * Cleanup includes in node.{hpp,cpp}.
  * Move HpPosRecProduct class to its own files.
  * Move HpgRefProduct class to its own files.
  * Move UbloxFirmware9 class to its own files.
  * Move UbloxFirmware8 class to its own files.
  * Move UbloxFirmware7 to its own files.
  * Move UbloxFirmware7Plus class to its own header file.
  * Move UbloxFirmware6 class to its own files.
  * Move UbloxFirmware class to its own files.
  * Move RawDataProduct class into its own files.
  * Move HpgRovProduct class to its own files.
  * Move AdrUdrProduct class into its own files.
  * Move TimProduct class into its own file.
  * Make the node handle a member variable of UbloxNode.
  * Remove the last uses of the global variable.
  * Pass the nodehandle into more methods.
  * Start passing the node into functions.
  * Declare a few more booleans.
  * Declare a lot more parameters.
  * Finish removing the "enable" map.
  * Move some more boolean parameters to declarations.
  * Declare more parameters.
  * Convert a few more parameters over to being declared.
  * Declare the config_on_startup flag.
  * Make dat/set a declared parameter.
  * Make sure to declare the sbas parameter.
  * Add in ROS2-like declare and get parameters.
  * Replace templated publish call with lambdas.
  * Make fix_status_service a member variable of UbloxFirmware.
  * Move fixFromString and modelFromString into node.cpp
  * Make gps a member variable of UbloxNode.
  * Add namespaces to component_interface and fts_product.hpp
  * Minor code improvements.
  * Move FixDiagnostic class to its own file.
  * Move UbloxTopicDiagnostic to its own file.
  * Make gnss a member variable of UbloxNode.
  * Move kNavSvInfoSubscribeRate into the base class that uses it.
  * Remove kSubscribeRate.
  * Move the kDefaultMeasRate to the class that needs it.
  * Remove kROSQueueSize constant.
  * Make rtcms a member variable of UbloxNode.
  * Switch to a structure for RTCMs.
  * Make freq_diag a member variable of UbloxNode.
  * Make updater a member variable of UbloxNode.
  * Make frame_id a member variable.
  * Make config_on_startup_flag a member variable.
  * Make meas_rate a member variable.
  * Make nav_rate a class variable.
  * Lots of small code updates throughout the GPS module.
  * Get rid of global 'debug' variable.
  * Move serialization into the ublox_serialization module.
  * More rearrangement of header files to make a more sane structure.
  * Move FTSProduct class into its own file.
  * UbloxNode is not a component.
  * Move ComponentInterface to its own file.
  * Remove the one static ros::Subscriber.
  * Remove last static advertiser.
  * Switch to const references for std::string where possible.
  * Switch to more idiomatic publisher initialization.
  * Switch the one use of tf to tf2.
  * Remove 'using namespace' uses.
  * Switch to non-boost asio.
  * Remove uses of 'new' throughout the codebase.
  * Remove the last of boost from node.cpp
  * Remove most of boost from node.cpp/.hpp.
  * Remove a bunch of boost from node.cpp
  * Remove more boost.
  * Remove boost from worker.hpp
  * Remove some uses of boost from async_worker.hpp
  * Fully de-boostify callback.hpp
  * Rearrange messages.
  * Switch out boost time and mutex for std
  * Remove trailing whitespace in all files.
  * Rename header files to have .hpp extension.
  * Contributors: Chao Qu, Chris Lalancette, Mabel Zhang

 -- Gareth Cross <gcross.code@icloud.com>  Tue, 13 Oct 2020 07:00:00 -0000



=== debian/control ===
Source: ros-rolling-ublox-gps
Section: misc
Priority: optional
Maintainer: Gareth Cross <gcross.code@icloud.com>
Build-Depends: debhelper (>= 9.0.0), libasio-dev, ros-rolling-ament-cmake-ros, ros-rolling-diagnostic-msgs, ros-rolling-diagnostic-updater, ros-rolling-geometry-msgs, ros-rolling-rcl-interfaces, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-tf2, ros-rolling-ublox-msgs, ros-rolling-ublox-serialization, ros-rolling-ros-workspace
Homepage: http://ros.org/wiki/ublox
Standards-Version: 3.9.2

Package: ros-rolling-ublox-gps
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libasio-dev, ros-rolling-diagnostic-msgs, ros-rolling-diagnostic-updater, ros-rolling-geometry-msgs, ros-rolling-rcl-interfaces, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-sensor-msgs, ros-rolling-std-msgs, ros-rolling-tf2, ros-rolling-ublox-msgs, ros-rolling-ublox-serialization, ros-rolling-ros-workspace
Description: Driver for u-blox GPS devices.

=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
